// Copyright (C) 2026 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
// Qt-Security score:significant reason:default

#ifndef QCONTACTGLOBALPRESENCE_H
#define QCONTACTGLOBALPRESENCE_H

#include <QtCore/qdatetime.h>
#include <QtCore/qurl.h>

#include <QtContacts/qcontactdetail.h>
#include <QtContacts/qcontactpresence.h>

QT_BEGIN_NAMESPACE_CONTACTS

class QContactFilter;

/* Leaf class */
class Q_CONTACTS_EXPORT QContactGlobalPresence : public QContactDetail
{
public:
#ifndef Q_QDOC
    Q_DECLARE_CUSTOM_CONTACT_DETAIL(QContactGlobalPresence)
#else
    static const DetailType Type;
#endif

    enum GlobalPresenceField {
        FieldTimestamp = 0,
        FieldNickname,
        FieldPresenceState,
        FieldPresenceStateText,
        FieldPresenceStateImageUrl,
        FieldCustomMessage
    };

    void setTimestamp(const QDateTime& _timestamp);
    QDateTime timestamp() const;
    void setNickname(const QString& _nickname);
    QString nickname() const;
    void setPresenceState(QContactPresence::PresenceState _presenceState);
    QContactPresence::PresenceState presenceState() const;
    void setPresenceStateText(const QString& _presenceStateText);
    QString presenceStateText() const;
    void setPresenceStateImageUrl(const QUrl& _presenceStateImageUrl);
    QUrl presenceStateImageUrl() const;
    void setCustomMessage(const QString& _customMessage);
    QString customMessage() const;

    // convenience filtering functions
    static QContactFilter match(QContactPresence::PresenceState state);
};

QT_END_NAMESPACE_CONTACTS

#endif // QCONTACTGLOBALPRESENCE_H
